<?php

namespace Contabilidade\Logic\Razao;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use \Setforms2\Shared\Registry;


/**
 * Class Razao
 * @package Contabilidade\Logic\Razao
 */
class Razao
{
    /**
     * @param $empresa
     * @param $containicial
     * @param $contafinal
     * @param $datainicial
     * @param $datafinal
     * @throws \Exception
     */
    public static function geraRazao($empresa, $containicial, $contafinal, $datainicial, $datafinal)
    {
        try{
            $nrrazao = '';
            $procedure = new Procedure('RAZAO_OFICIAL');
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $empresa, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCONTINI', Param::PARAM_INPUT, $containicial, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCONTFIN', Param::PARAM_INPUT, $contafinal, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $datainicial, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $datafinal, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRRAZAO', Param::PARAM_OUTPUT, $nrrazao, Param::PARAM_TYPE_INT, 12));
            $nrrazao = $procedure->call();
            return $nrrazao['P_NRRAZAO'];



        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public static function excluirRelatorio()
    {
        try {
            $nrrazao = tk_get_field_value('NRRAZAO');
            $nrorg = tk_get_field_value('NRORG');
            $razoes = \Contabilidade\Entities\Razao::findByNrrazaoAndNrorg($nrrazao, $nrorg);
            foreach($razoes as $razao)
                $razao->delete();
            Registry::getEntityManager()->flush();
        }catch (\Exception $e)
        {
            throw $e;
        }
    }
}
