package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.NutrientesFlows;
import com.javaseleniumtemplate.pages.NutrientesPage;
import org.testng.annotations.Test;

public class NutrientesTests extends TestBase {

    NutrientesPage nutrientesPage;
    NutrientesFlows nutrientesFlows;
    LoginFlows loginFlows;

    //adicionar um nutriente
    //verificar os dados do nutriente adicionado
    //editar os dados do nutriente e verificar os mesmos
    //excluir o nutriente adicionado
    @Test
    public void adcionarNutriente() {
        nutrientesPage = new NutrientesPage();
        nutrientesFlows = new NutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesFlows.navegateNutrientes();
        nutrientesPage.adicionarNutriente();
        nutrientesPage.verificarDadosAdicionados();
        nutrientesPage.editarNutrienteAdicionado();
        nutrientesPage.verificarDadosEditados();
        nutrientesPage.excluirNutriente();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar os campos obrigatórios do formulário para adicionar um novo nutriente
    //adicionar um novo nutriente
    //tentar adicionar um nutriente com código já existente e verificar a mensagem que é exibida na tela
    //tentar excluir um nutriente que possui registros filhos, verificar a mensagem que foi exibida na tela e verificar se o nutriente não foi removido
    //alterar a ordem dos nutrientes
    @Test
    public void adicionarCodigoExistente() {
        nutrientesPage = new NutrientesPage();
        nutrientesFlows = new NutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesFlows.navegateNutrientes();
        nutrientesPage.camposObrigatorios();
        nutrientesPage.refresh();
        nutrientesPage.adicionarNutriente();
        nutrientesPage.adicionarCodigoExistente();
        nutrientesPage.refresh();
        nutrientesPage.tentarExcluirNutrRegisFilho();
        nutrientesPage.alterarOrdem();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
